using Windows.Foundation.Metadata;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Media.Animation;
using Windows.UI.Xaml.Navigation;

namespace TestProject
{
    /// <summary>
    ///   2
    /// </summary>
    public sealed partial class SamplePage2 : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - SamplePage2()

        /// <summary>
        /// 
        /// </summary>
        public SamplePage2()
        {
            InitializeComponent();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ִϸ̼ غϱ - PrepareConnectedAnimation(configuration)

        /// <summary>
        ///  ִϸ̼ غϱ
        /// </summary>
        /// <param name="configuration"> ִϸ̼ </param>
        public void PrepareConnectedAnimation(ConnectedAnimationConfiguration configuration)
        {
            ConnectedAnimation animation = ConnectedAnimationService.GetForCurrentView().PrepareToAnimate("BackwardAnimation", this.targetGrid);

            if(configuration != null && ApiInformation.IsApiContractPresent("Windows.Foundation.UniversalApiContract", 7))
            {
                animation.Configuration = configuration;
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region Ž Ǵ  óϱ - OnNavigatedTo(e)

        /// <summary>
        /// Ž Ǵ  óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);

            ConnectedAnimation animation = ConnectedAnimationService.GetForCurrentView().GetAnimation("ForwardAnimation");

            if(animation != null)
            {
                SetContentStackPanelTransitionCollection();

                animation.TryStart(this.targetGrid);
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Ʈ  г  ÷ ϱ - SetContentStackPanelTransitionCollection()

        /// <summary>
        /// Ʈ  г  ÷ ϱ
        /// </summary>
        private void SetContentStackPanelTransitionCollection()
        {
            this.contentStackPanel.Transitions = new TransitionCollection { new EntranceThemeTransition() };
        }

        #endregion
    }
}